class PidFunc;

class FuncStats
{
    public:

		FuncStats( int aifuncname );

	int	GetIFuncName();
	int	GetNComputes();
	int	GetNElapseds();

	void	SetIFuncName( int aifuncname );

	void	UpdateCompute( PidFunc *ppidfunc, double compute );
	void	BackoutCompute( PidFunc *ppidfunc, double compute );
	void	UpdateElapsed( PidFunc *ppidfunc, double elapsed );
	void	Print();

    private:

	int ifuncname;

	FuncExtremes maxfcomputes;
	FuncExtremes minfcomputes;
	double sumcomputes;
	int ncomputes;

	FuncExtremes maxfelapseds;
	FuncExtremes minfelapseds;
	double sumelapseds;
	int nelapseds;
};
