#ifndef NONAMESPACE

#include <iostream>
using namespace std;

#else

#include <iostream.h>

#endif

void PrintUsage()
{
	cout << "p4loga analyzes a p4d server log file to help determine\n";
	cout << "how the p4d server is performing. p4loga is only useful\n";
	cout << "when analyzing a p4d server log file when the p4d server\n";
	cout << "has been started with either the -vserver=2 or -vserver=3\n";
	cout << "option.\n";
	cout << "\n";
	cout << "Usage: p4loga [options] [file]\n";
	cout << "\n";
	cout << "where options are:\n";
	cout << "\n";
	cout << "  --detail      Print a line for each completed function.\n";
	cout << "                By default, detail lines are not printed.\n";
	cout << "\n";
	cout << "  --csv         Prints a line containing comma-seperated variables\n";
	cout << "                for each completed function.\n";
	cout << "                No header or summary information is printed\n";
	cout << "                This output can be imported to a spreadsheet\n";
	cout << "                or database for further analysis.\n";
	cout << "                Can not be combined with '--detail'.\n";
	cout << "\n";
	cout << "  --begin=time  Consider only log file records with\n";
	cout << "                timestamps greater than or equal to\n";
	cout << "                the timestamp provided. For example,\n";
	cout << "                --begin=\"2001/10/01 00:00:00\" will\n";
	cout << "                consider all log records with timestamps\n";
	cout << "                in October of 2001 and later. By default,\n";
	cout << "                all log records with timestamps greater\n";
	cout << "                than or equal to 1990/01/01 00:00:00\n";
	cout << "                will be considered.\n";
	cout << "\n";
	cout << "  --end=time    Consider only log file records with\n";
	cout << "                timestamps less than or equal to\n";
	cout << "                the timestamp provided. For example,\n";
	cout << "                --end=\"2001/10/31 23:59:59\" will\n";
	cout << "                consider all log records with timestamps\n";
	cout << "                in October of 2001 and earlier. By default,\n";
	cout << "                all log records with timestamps less\n";
	cout << "                than or equal to 2029/12/31 23:59:59\n";
	cout << "                will be considered.\n";
	cout << "\n";
	cout << "and file is the -vserver=2 or -vserver=3 p4d server log.\n";
	cout << "The default log file name is \"log\".\n";
	cout << "\n";
}
